<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
    <!-- Installation de vueJS -->
    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
</head>
<body>
<div id="vue-app">
    <nav>
        <a v-if="token==null" @click="etatInterface='connexion'" href="#">Connexion</a>
        <a v-if="token==null" @click="etatInterface='inscription'" href="#">Inscription</a>
        <a v-if="token!=null" @click="clickDisconnect()" href="#">Déconnexion</a>
        <a v-if="token!=null" @click="clicProfil()" href="#">Profil</a>
    </nav>
    <!-- Formulaire d'iunscription -->
    <form v-if="etatInterface=='inscription'">
        <h1>Inscription</h1>
        <label>email</label>
        <input v-model="inscription.username">
        <label>Password</label>
        <input v-model="inscription.password">
        <label>Retapez le Password</label>
        <input v-model="inscription.password2">
        <input @click="clicInscription()" type="button" value="Connect">
    </form>
    <!-- Formulaire de connexion -->
    <form v-if="etatInterface=='connexion'">
        <h1>Connexion</h1>
        <label>email</label>
        <input v-model="connexion.username">
        <label>Password</label>
        <input v-model="connexion.password">
        <input @click="clicConnexion()" type="button" value="Connect">
    </form>

    <div v-html="form"></div>

    <div v-if="etatInterface=='profil'">
        <h1>Profil</h1>
        <span>Votre pseudo : ${ profil.email }</span>
    </div>
</div>
<!-- JS avec vuejs -->
<script>
    var app = new Vue({
        el: '#vue-app',
        delimiters: ['${', '}'],
        mounted:function(){
            //On récupère la valeur en localstorage
            this.token = localStorage.getItem('Token');
            console.log(this.token);

            //Pour vérifier si dans l'url il y a /f... alors exe la f° clicProfil
            if(null !== this.token) { //donne l'url qu'il y a dans mon navigateur
                this.clicProfil() //method will execute at pageload //redirection sur la page de profil
            }
            console.log(location.pathname.substr(1));
        },
        data: {
            token: null,
            etatInterface: null,
            form: null,
            profil: {
                email: ''
            },
            connexion: {
                username: '',
                password: ''
            },
            inscription: {
                username: '',
                password: '',
                password2: ''
            }
        },
        methods: {
            sendAjax: async function (url, method, obj=null) {

                var params = {
                    method: method,
                    headers: {
                        'Accept': 'application/json',
                        'Content-Type': 'application/json'
                    },
                }

                if( obj ){
                    params['body']=JSON.stringify(obj);
                }

                if( this.token!=null ){
                    params.headers.Authorization = 'Bearer ' + this.token;
                }

                var resp = await fetch(url, params);
                var json = await resp.json();

                return json;
            },
            clicInscription: async function () {

                var url = '{{ path('api_register') }}';
                var json = await this.sendAjax(url,'post', this.inscription);

                alert( `${json.status}\n\n${json.message}` );

                // Switch vers connexion si OK
                if( json.status==200 ){
                    this.inscription.password='';
                    this.inscription.password2='';
                    this.inscription.username='';

                    this.etatInterface='connexion';
                }
            },
            clickDisconnect: async function () {
                localStorage.removeItem('Token');
                this.token = null;
                this.etatInterface = 'connexion';
            },
            clicConnexion: async function () {

                // Requête ajax de connexion
                var url = '{{ path('api_login_check') }}';
                var resp = await this.sendAjax(url, 'post', this.connexion);

                // Quitte si erreur
                if( resp.token==undefined ){
                    alert( resp.message );
                    return;
                }

                // Pas d'erreur => On stocke le token dans le data vuejs
                this.token = resp.token;

                // ETAPE : RECUP TOKEN
                // local Storage
                localStorage.setItem('Token', this.token);

                // Charge infos de profil
                this.clicProfil();
            },
            clicProfil: async function(){

                // Charge données de profil
                const url = '{{ path('api_profile') }}';
                var resp = await this.sendAjax(url,'get');
                this.profil=resp;

                // Changé état interface
                this.etatInterface = 'profil';
            }
        }
    });
</script>
</body>
</html>